import { generateSQLCreateTable, generateSQLInsertInto } from '../stringSQL';
import { openDbSqlite } from './openDbSqlite';
// import { SqliteStore } from '.'; //TODO: не получается использовать классовые методы, typescript ругается

export type CreateTableType = (payload: object, tableName: string, isCreateDate?: boolean) => Promise<{status: boolean}> 

export const createAndWriteInTable: CreateTableType = (payload, tableName, isCreateDate) => new Promise<{status: boolean}>((resolve, reject) => {
  let db = openDbSqlite((process.env.REACT_APP_SQLITE_DB_NAME as string)); //намеренно не избавляюсь т.к. из-за использования других функций всё равно имеет зависимость, так хоть аргументов меньше

  let { newSQLCreate } = generateSQLCreateTable(payload, tableName, isCreateDate)
  let { newSQLInsert, arrValuesPayload } = generateSQLInsertInto(payload, tableName);

  db.transaction(
    (tx) => {
      tx.executeSql(`DROP TABLE IF EXISTS ${tableName}`);
      tx.executeSql(newSQLCreate);
      tx.executeSql(newSQLInsert, arrValuesPayload, () => resolve({status: true}));
    },
    (err) => { console.error(`>>> Ошибка в SqliteStore -> createTable <<<: ${err}`); reject(new Error('Не удалось создать и записать в таблицу'))  },
    () => { console.dir('Успешное создание таблицы');  }
  )

})

