import { openDbSqlite } from './openDbSqlite';


export function overwriteOldData (nameTable, keyName, version, rawData) {
  return new Promise((resolve, reject) => {
    console.group('overwriteOldData')
 
    if(window.cordova && window.sqlitePlugin){ 
      let db = openDbSqlite();
      
      db.transaction(
        (tx) => {
       
          console.dir(`UPDATE ${nameTable} SET version = ?, rawData = ?, planData = ? WHERE name=${keyName}`);
          tx.executeSql(`UPDATE ${nameTable} SET version = ?, rawData = ?, planData = ? WHERE name=${keyName}`, 
            [
              (typeof version  === 'string') ? Number(version) : version,
              (typeof rawData  === 'object') ? JSON.stringify(rawData) : rawData.trim(),
              ''
            ],
            (tx, res) => {
              console.dir('Данные обновлены возвращаю res.insertId');
              console.dir(res);

              resolve(res.insertId); 
            },
            (tx, err) => console.error(err)
          ); 
        },
        //При проверке таблицы не закрывать бд т.к. она закрывается в момент транзакции getDataFromSqlite
        (error) => { console.log('Ошибка транзакции в overwriteOldData: '); reject(error);  }, 
        () => { console.log('Успех транзакции overwriteOldData');  } 
      );

      return;
    }
    reject(new Error('Не установлен плагин cordova || cordova-sqlite-storage'));

  })
}
